﻿using System;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;          // !
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication3
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private int[] zahlen = {5, -4, 18, 26, 0, 19, 16, 2, -1, 0, 9, -5, 8, 15, 19 };

        // Query Expression Syntax:
        private void button1_Click(object sender, EventArgs e)
        {
            var expr = from z in zahlen
                                       where z > 10
                                       orderby z
                                       select z;

            foreach (int z in expr)
                listBox1.Items.Add(z.ToString());
        }

        // Extension Method Syntax:
        private void button2_Click(object sender, EventArgs e)
        {
            var expr = zahlen
                                       .Where(z => z > 10)
                                       .OrderBy(z => z)
                                       .Select(z => z);

            foreach (int z in expr)
                listBox1.Items.Add(z.ToString());
        }

        // Gemischte Syntax:
        private void button3_Click(object sender, EventArgs e)
        {
            var expr = (from z in zahlen
                                       where z > 10
                                       select z).
                                       OrderBy(z => z);

            foreach (int z in expr)
                listBox1.Items.Add(z.ToString());

        }

        // ListBox-Inhalt löschen:
        private void button4_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
        }


    }
}
