using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace UpdateDemo
{
    using System.Data.OleDb;

    public partial class Form1 : Form
    {
        private OleDbConnection conn = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=Nordwind.mdb;");
        private OleDbDataAdapter da = null;
        private DataSet ds = null;
        

        public Form1()
        {
            InitializeComponent();
        }


        public DataSet getArtikel()
        {
            // SelectCommand-Objekt fr DataAdapter erstellen:
            string selStr = "SELECT ArtikelNr, Artikelname, Einzelpreis, Mindestbestand FROM Artikel ORDER BY Artikelname";
            da = new OleDbDataAdapter(selStr, conn);
            da.MissingSchemaAction = MissingSchemaAction.AddWithKey;   // !
            DataSet ds = new DataSet();
            conn.Open();
            da.Fill(ds, "Artikel");
            conn.Close();
            return ds;
        }

        public void setArtikel(ref DataSet ds)
        {
            OleDbCommandBuilder cb = new OleDbCommandBuilder(da);   // das reicht!

            conn.Open();
            da.Update(ds, "Artikel");
            conn.Close();
        }

        private void formatDataGridView(DataGridView dgv)
        {
            // Einzelpreis formatieren:
            dgv.Columns.Remove("Einzelpreis");
            DataGridViewTextBoxColumn tbc = new DataGridViewTextBoxColumn();
            tbc.DataPropertyName = "Einzelpreis";
            tbc.HeaderText = "Einzelpreis";
            tbc.Width = 80;
            tbc.DefaultCellStyle.Format = "c";
            tbc.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
            tbc.DefaultCellStyle.Font = new Font(dataGridView1.Font, FontStyle.Bold);
            tbc.DisplayIndex = 2;
            dgv.Columns.Add(tbc);
        }

        // Anzeigen:
        private void button1_Click(object sender, EventArgs e)
        {
            dataGridView1.DataSource = null;
            ds = getArtikel();
            dataGridView1.DataSource = ds;  	// DataGridView mit DataSet verbinden
            dataGridView1.DataMember = "Artikel";
            formatDataGridView(dataGridView1);
       
            button2.Enabled = true;
            label1.Visible = true;
        }

        // Aktualisieren:
        private void button2_Click(object sender, EventArgs e)
        {
            DataSet ds1 = ds.GetChanges();
            if (ds1 != null)
            {
                // nderungen in Datenbank schreiben:
                try
                {
                    setArtikel(ref ds1);
                    ds.Merge(ds1);
                    ds.AcceptChanges();
                    MessageBox.Show("Datenbank wurde aktualisiert!", "Erfolg");
                }
                catch (Exception ex)
                {
                    ds.RejectChanges();
                    MessageBox.Show(ex.Message, "Fehler");
                }
            
            }
        }

    }
}