using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace RowUpdatingDemo
{
    using System.Data.OleDb;

    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private string CrLf = Environment.NewLine;
        private string s = String.Empty;

        private DataTable dt = null;
        private OleDbDataAdapter da = null;

        private void Form1_Load(object sender, EventArgs e)
        {
            OleDbConnection conn = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0; Data Source=Nordwind.mdb;");
            da = new OleDbDataAdapter("SELECT TOP 1 ArtikelNr, Artikelname, Lagerbestand FROM Artikel", conn);

            da.RowUpdating += new OleDbRowUpdatingEventHandler(this.onRowUpdating);
            da.RowUpdated += new OleDbRowUpdatedEventHandler(this.onRowUpdated);
            dt = new DataTable("Artikel");
            da.Fill(dt);

            //OleDbCommandBuilder cb = new OleDbCommandBuilder(da);       
            OleDbCommand cmd = new OleDbCommand(
                               "UPDATE Artikel SET Lagerbestand = ? WHERE ArtikelNr = ?", conn);
            cmd.Parameters.Add("?", OleDbType.Integer, 4, "Lagerbestand");
            cmd.Parameters.Add("?", OleDbType.Integer, 4, "ArtikelNr");
            da.UpdateCommand = cmd;
        }

            // Der Eventhandler fr RowUpdating:
            private void onRowUpdating(object sender, OleDbRowUpdatingEventArgs e)
            {
                s += "Ereignis: " + e.StatementType.ToString() + CrLf;
                s += "Artikel-Nr: " + e.Row["ArtikelNr"].ToString() + CrLf;
                s += "Lagerbestand davor: " + e.Row["Lagerbestand", DataRowVersion.Original].ToString() + CrLf;
	            s += "Lagerbestand danach: " + e.Row["Lagerbestand"].ToString() + CrLf + CrLf;
            }
    
            // Der Eventhandler fr RowUpdated:
            private void onRowUpdated(object sender, OleDbRowUpdatedEventArgs e)
            {
                s += "Ereignis: " + e.StatementType.ToString() + CrLf;
                s += "Artikel-Nr: " + e.Row["ArtikelNr"].ToString() + CrLf;
                if (e.Status == UpdateStatus.ErrorsOccurred) 
                {
                    s += "Fehler!" + CrLf;
	            }
	            else
	            {
		            s += "Update erfolgreich!" + CrLf + CrLf;
	            }
	            label1.Text = s; s = "";
            }
    
            // Die Routine zum Verndern des Lagerbestands:
            private void changeStock(int z)
            {
	            try
	            {
                    // Die erste (und einzige!) Zeile der DataTable:
		            DataRow dr = dt.Rows[0];     	
		            int i = Convert.ToInt32(dr["Lagerbestand"]); 
		            dt.Rows[0]["Lagerbestand"] =  i + z;
		            da.Update(dt);
	            }
	            catch(Exception ex)
	            {
		            MessageBox.Show(ex.Message);
	            }
            }

        // Lagebestand erhhen:
        private void button1_Click(object sender, EventArgs e)
        {
             changeStock(1);
        }

        // Lagerbestand verringern:
        private void button2_Click(object sender, EventArgs e)
        {
             changeStock(-1);
        }    

     }
}