﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Data;
using System.Data.OleDb;

namespace NordwindDAL
{
    public class CKunde
    {
        public string KundenCode { get; set; }
        public string Firma { get; set; }
        public string Kontaktperson { get; set; }
        public string Funktion { get; set; }
    }

    public class CKundenDAL
    {
        private OleDbConnection conn = null;

        public void OpenConnection(string connStr)
        {
            conn = new OleDbConnection();
            conn.ConnectionString = connStr;
            conn.Open();
        }

        public void CloseConnection()
        {
            conn.Close();
        }

        public DataTable GetAllKunden()
        {
            DataTable kunden = new DataTable();

            string sql = "SELECT * FROM Kunden";

            using (OleDbCommand cmd = new OleDbCommand(sql, this.conn))
            {
                OleDbDataReader dr = cmd.ExecuteReader();
                kunden.Load(dr);
                dr.Close();
            }
            return kunden;
        }

        public void InsertKunde(CKunde kd)
        {
            string sql = String.Format("INSERT INTO Kunden " +
               "(KundenCode, Firma, Kontaktperson, Funktion) Values " +
               "('{0}', '{1}', '{2}', '{3}')", kd.KundenCode, kd.Firma, kd.Kontaktperson, kd.Funktion);
            
            using (OleDbCommand cmd = new OleDbCommand(sql, this.conn))
            {
                cmd.ExecuteNonQuery();
            }
        }

        public void UpdateKunde(CKunde kd)
        {
            string sql = String.Format(
                  "UPDATE Kunden SET Firma = '{0}', Kontaktperson = '{1}', Funktion = '{2}' WHERE KundenCode = '{3}'", 
                     kd.Firma, kd.Kontaktperson, kd.Funktion, kd.KundenCode);
            
            using (OleDbCommand cmd = new OleDbCommand(sql, this.conn))
            {
                cmd.ExecuteNonQuery();
            }
        }

        public void DeleteKunde(string kdCode)
        {
            string sql = string.Format("DELETE FROM Kunden WHERE KundenCode = '{0}'", kdCode);

            using (OleDbCommand cmd = new OleDbCommand(sql, this.conn))
            {
                try
                {
                    cmd.ExecuteNonQuery();
                }
                catch (OleDbException ex)
                {
                    Exception error = new Exception("Kunde darf nicht gelöscht werden!", ex);
                    throw error;
                }
            }
        }
    }
}
