using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Data.SqlClient;         // !

namespace AsynchroneBefehle
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        const string CONNSTR = "Data Source=.\\SQLEXPRESS; Initial Catalog=Northwind; Integrated Security=sspi;" +
                               "Async=true";    // !
                               
        const string SQL = "SELECT * FROM Customers ORDER BY CompanyName";

        private void showReader(IDataReader dr)
        {
            string str;
            string spc = "   ";
            listBox1.Items.Clear();
            while (dr.Read())
            {
                str = dr["CustomerID"] + spc;
                str += dr["CompanyName"] + spc;
                str += dr["ContactName"] + spc;
                str += dr["ContactTitle"] + spc;
                str += dr["Address"] + spc;
                str += dr["City"] + spc;
                listBox1.Items.Add(str);
            }
            dr.Close();
            MessageBox.Show("Asynchrone Operation beendet!");
        }

        // Polling-Pattern:
        private void button1_Click(object sender, EventArgs e)
        {
            SqlConnection conn = new SqlConnection(CONNSTR);
            conn.Open();

            SqlCommand cmd = new SqlCommand(SQL, conn);

            IAsyncResult res = cmd.BeginExecuteReader(CommandBehavior.CloseConnection);

            progressBar1.Value = 0;
            while (!res.IsCompleted)  // so lange bis Reader fertig ist, knnen andere Aufgaben erledigt werden ...
            {
                if (progressBar1.Value < progressBar1.Maximum) progressBar1.Value++;    // ..., z.B. Fortschrittsanzeige
            }
            SqlDataReader dr = cmd.EndExecuteReader(res);    // Ergebnis auswerten
            showReader(dr);
         }
             
                
    }
}