﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Data.OleDb;
using System.IO;
using System.Diagnostics;
using System.Reflection;
using System.Runtime.InteropServices;
using Excel = Microsoft.Office.Interop.Excel;


namespace Excel_Bsp
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (File.Exists("MeinExport.xls")) File.Delete("MeinExport.xls");

            using (OleDbConnection xlsconn = new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=MeinExport.xls;Extended Properties=""Excel 8.0;HDR=Yes"""))
            {
                OleDbCommand cmd = xlsconn.CreateCommand();
//                cmd.CommandText = "CREATE TABLE [MeineExportdaten] (Vorname char(255), Nachname char(255), Gehalt char(255))";
                cmd.CommandText = "CREATE TABLE [MeineExportdaten] (Vorname char(255), Nachname char(255), Gehalt Currency)";
                
                xlsconn.Open();
                cmd.ExecuteNonQuery();
                xlsconn.Close();
            }

            Process.Start("MeinExport.xls");

        }

        private void button2_Click(object sender, EventArgs e)
        {
            using (OleDbConnection xlsconn = new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=MeinExport.xls;Extended Properties=""Excel 8.0;HDR=Yes"""))
            {
                OleDbCommand cmd = xlsconn.CreateCommand();
                xlsconn.Open();
                cmd.CommandText = "INSERT INTO [MeineExportdaten$] (Vorname, Nachname, Gehalt) values ('Thomas', 'Gewinnus', 3456)";
                cmd.ExecuteNonQuery();
                cmd.CommandText = "INSERT INTO [MeineExportdaten$] (Vorname, Nachname, Gehalt) values ('Walter', 'Doberenz', 3856)";
                cmd.ExecuteNonQuery();
                cmd.CommandText = "INSERT INTO [MeineExportdaten$] (Vorname, Nachname, Gehalt) values ('Edwin', 'Müller', 1234)";
                cmd.ExecuteNonQuery();
                xlsconn.Close();
                
            }
            Process.Start("MeinExport.xls");
        }

        private void button3_Click(object sender, EventArgs e)
        {
            using (OleDbConnection xlsconn = new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=MeinExport.xls;Extended Properties=""Excel 8.0;HDR=Yes"""))
            {
                OleDbCommand cmd = xlsconn.CreateCommand();
                xlsconn.Open();
                cmd.CommandText = "UPDATE [MeineExportdaten$] SET Gehalt= 2500 WHERE Nachname='Müller'";
                cmd.ExecuteNonQuery();
                xlsconn.Close();
            }
            Process.Start("MeinExport.xls");
        }

        private void button4_Click(object sender, EventArgs e)
        {
            using (OleDbConnection xlsconn = new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=MeinExport.xls;Extended Properties=""Excel 8.0;HDR=Yes"""))
            {
                OleDbCommand cmd = xlsconn.CreateCommand();
                cmd.CommandText = "SELECT * FROM [MeineExportdaten$]";
                xlsconn.Open();
                OleDbDataReader dr = cmd.ExecuteReader();
                while (dr.Read())
                {
                    listBox1.Items.Add(dr["Vorname"].ToString() + " " + dr["Nachname"] + " = " + dr["Gehalt"]);
                }
                xlsconn.Close();
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            using (OleDbConnection xlsconn = new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=MeinExport.xls;Extended Properties=""Excel 8.0"""))
            {
                xlsconn.Open();
                DataTable dt = xlsconn.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, null);
                string firstsheet = dt.Rows[0]["TABLE_NAME"].ToString();

                OleDbCommand cmd = xlsconn.CreateCommand();
                cmd.CommandText = "SELECT * FROM [" + firstsheet + "$]";
                OleDbDataReader dr = cmd.ExecuteReader();
                while (dr.Read())
                {
                    listBox1.Items.Add(dr[0] + " " + dr[1] + " = " + dr[2]);
                }
                xlsconn.Close();
            }

        }

        private void button6_Click(object sender, EventArgs e)
        {
            if (File.Exists("MeinExport.xlsx")) File.Delete("MeinExport.xlsx");

            using (OleDbConnection xlsconn = new OleDbConnection(@"Provider=Microsoft.ACE.OLEDB.12.0;Data Source=MeinExport.xlsx;Extended Properties=""Excel 12.0 Xml"""))
            {
                OleDbCommand cmd = xlsconn.CreateCommand();
                cmd.CommandText = "CREATE TABLE MeineExportdaten (Vorname char(255), Nachname char(255), Gehalt char(255))";
                xlsconn.Open();
                cmd.ExecuteNonQuery();
                xlsconn.Close();
            }

            Process.Start("MeinExport.xlsx");

        }

        private void button7_Click(object sender, EventArgs e)
        {
            dataGridView1.DataSource = LoadDataTableRange(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=MeinExport.xls;Extended Properties=""Excel 8.0;HDR=Yes""", "MeineExportdaten", "A1:B3");
        }

        private DataTable LoadDataTable(String connection, String sheet)
        {
            DataTable dt = new DataTable(sheet);
            using (OleDbConnection xlsconn = new OleDbConnection(connection))
            {
                try
                {
                    xlsconn.Open();
                    OleDbDataAdapter da = new OleDbDataAdapter("SELECT * FROM [" + sheet + "$]", xlsconn);
                    da.Fill(dt);
                    xlsconn.Close();
                }
                catch (Exception)
                { }
                return dt;
            }
        }

        private DataTable LoadDataTableRange(String connection, String sheet, string range)
        {
            DataTable dt = new DataTable(sheet);
            using (OleDbConnection xlsconn = new OleDbConnection(connection))
            {
                try
                {
                    xlsconn.Open();
                    OleDbDataAdapter da = new OleDbDataAdapter("SELECT * FROM [" + sheet + "$" + range + "]", xlsconn);
                    da.Fill(dt);
                    xlsconn.Close();
                }
                catch (Exception)
                { }
                return dt;
            }
        }


        private void button8_Click(object sender, EventArgs e)
        {
            dataGridView1.DataSource = LoadDataTable(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=MeinExport.xls;Extended Properties=""Excel 8.0""", "MeineExportdaten");
        }

        private void button9_Click(object sender, EventArgs e)
        {
            var eApp = new Excel.Application();
            eApp.Visible = true;
            eApp.Workbooks.Open(Application.StartupPath + @"\MeinExport.xls");
            eApp.Range["A1:C1"].Select();
            eApp.Selection.Font.Bold = true;
            eApp.Range["C2:C5"].Select();
            eApp.Selection.Style = "Currency";
            eApp.Range["C5"].Activate();
            eApp.ActiveCell.FormulaR1C1 = "=SUM(R[-3]C:R[-1]C)";
            eApp.Range["C5"].Select();
            eApp.Selection.Font.Bold = true;
            eApp.Columns["B:B"].ColumnWidth = 11.43;
            eApp.Columns["C:C"].ColumnWidth = 11.43;
            eApp.ActiveWorkbook.Save();
         //   eApp.Quit();
        }

        private void button10_Click(object sender, EventArgs e)
        {
            var eApp = new Excel.Application();
            eApp.Visible = true;
            dynamic wkBook = eApp.Workbooks.Add();
            Excel.Worksheet wsData = wkBook.ActiveSheet;
            wsData.Cells[1, 1] = "Name";
            wsData.Cells[1, 2] = "Gehalt";
            var data = new string[,] { {"Walter Doberenz", "4000"},{"Thomas Gewinnus", "3900"}};
            var dRange = wsData.get_Range("A2", "B3");
            dRange.Value2 = data;
            Excel.Worksheet wsEnd = wkBook.Worksheets.Add(After: wsData);
            wsEnd.Cells[2, 2] = "Testeintrag";
            wkBook.SaveAs(Application.StartupPath + "\\test.xls", Excel.XlSaveAsAccessMode.xlShared);
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }


    }
}
