using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Performance
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Start:
        private void button1_Click(object sender, EventArgs e)
        {
            DataSet ds = new DataSet();
            label2.Text = String.Empty;
            label3.Text = String.Empty;
            DateTime start = new DateTime();

            ds.Tables.Add("Test");
            ds.Tables[0].Columns.Add("Nr", Type.GetType("System.Int32"));
            ds.Tables[0].Columns["Nr"].Unique = true;              // eindeutiger Schlssel
            ds.Tables[0].Columns.Add("Wert", Type.GetType("System.String"));

            int n = Int32.Parse(textBox1.Text);  // Anzahl Iterationen
            this.Cursor = Cursors.WaitCursor;
            start = DateTime.Now;        // Startzeit
            Random rnd = new Random();   // Zufallszahlengenerator erzeugen
            
            // Hinzufgen von n Zeilen zur DataTable im DataSet: 
            for (int i = 1; i <= n; i++)
            try
            {
                int z = rnd.Next();    // neue Zufallszahl
                DataRow dr = ds.Tables[0].NewRow();
                dr["Nr"] = z;
                dr["Wert"] = z.ToString();
                ds.Tables[0].Rows.Add(dr);
            }
            catch { }    // Fehler bei doppeltem "Nr"-Wert
                         
            this.Cursor = this.DefaultCursor;   // Mauszeiger zurcksetzen


            TimeSpan ts = new TimeSpan(DateTime.Now.Ticks - start.Ticks); // Zeitdauer in Sekunden ermitteln

            // Ergebnisanzeige:
            label2.Text = ds.Tables["Test"].Rows.Count.ToString();   // tatschliche Anzahl der Zeilen anzeigen
            label3.Text = ts.TotalSeconds.ToString();
        }
    }
}