using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace FormsDataSource_Demo
{
    using System.Data.OleDb;

    public partial class Form1 : Form
    {
        private OleDbConnection conn = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0; Data Source = Nordwind.mdb;");
        private OleDbDataAdapter da = null;
        private DataTable dt = null;
        private DataView dv = null;
        private DataRowView drv = null;    

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            da = new OleDbDataAdapter("SELECT KundenCode, Firma, Kontaktperson, Funktion, Ort FROM Kunden ORDER BY KundenCode", conn);
            OleDbCommandBuilder cb = new OleDbCommandBuilder(da);
            dt = new DataTable("Kunden");
            conn.Open();
            da.Fill(dt);
            conn.Close();
            BindingSource bs = new BindingSource();
            dv = new DataView(dt);
            bs.DataSource = dv;
            dataGridView1.DataSource = bs;
        }

        // Bearbeiten:
        private void button1_Click(object sender, EventArgs e)
        {
            drv = dv[dataGridView1.CurrentRow.Index];
            Form2 f2 = new Form2();
            f2.editKunde(drv);
            f2.Dispose();
        }

        // Neu:
        private void button2_Click(object sender, EventArgs e)
        {
            drv = dv.AddNew();
            Form2 f2 = new Form2();
            f2.editKunde(drv);
            f2.Dispose();
        }

        // Speichern:
        private void button3_Click(object sender, EventArgs e)
        {
            DataTable dt1 = dt.GetChanges();
            if (!(dt1==null))
            {
                try
                {
                    conn.Open();
                    int m = da.Update(dt1);
                    string s = "Anzahl der nderungen: " + m.ToString();
                    MessageBox.Show(s, "Speichern war erfolgreich!", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    dt.AcceptChanges();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Speichern fehlgeschlagen!", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    dt.RejectChanges();
                }
                conn.Close();
            }
        }

        // Lschen:
        private void button4_Click(object sender, EventArgs e)
        {
            if (dv.Count > 0)
            {
                string msg = "Wollen Sie den Kunden " + dv[dataGridView1.CurrentRow.Index]["KundenCode"].ToString() + " wirklich lschen?";
                string cpt = "Kunde lschen";
                if (MessageBox.Show(msg, cpt, MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                    dv[dataGridView1.CurrentRow.Index].Delete();
            }
            else
                MessageBox.Show("Kein Kunde zum Lschen!", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
               
    }
}