using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ComboBoxTables_Demo
{
    using System.Data.OleDb;

    public partial class Form1 : Form
    {
        private string connStr = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=Nordwind.mdb;";
        private string selStrBest = "SELECT BestellNr, KundenCode, PersonalNr, Empfaenger, Bestelldatum, Frachtkosten " +
                      "FROM Bestellungen ORDER BY Bestelldatum";
        private string selStrPers = "SELECT PersonalNr, Nachname, Vorname, Funktion FROM Personal ORDER BY Nachname";

        private OleDbConnection conn = null;
        private OleDbDataAdapter daBest = null, daPers = null;
        private DataSet ds = null;
            
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            conn = new OleDbConnection(connStr);
            daBest = new OleDbDataAdapter(selStrBest, conn);
            // UpdateCommand, InsertCommand und DeleteCommand fr Bestellungen automatisch erstellen lassen:
            OleDbCommandBuilder cb = new OleDbCommandBuilder(daBest);
            // fr Personal braucht man nur das automatisch vorhandene SelectCommand:
            daPers = new OleDbDataAdapter(selStrPers, conn);
        	ds = new DataSet();
        	conn.Open();        

            // Ausfhren der SQL-Abfragen (Anlegen und Fllen der Tabellen):
	        daBest.Fill(ds, "Bestellungen");  // Ausfhren der SQL-Abfrage (Anlegen und Fllen der Tabelle "Bestellungen");
            daPers.Fill(ds, "Personal");
            conn.Close();  
            // Anbinden der Hauptmaske an Mastertabelle: 
	        bindingSourceBest.DataSource = ds.Tables["Bestellungen"]; 
            label1.DataBindings.Add("Text", bindingSourceBest, "BestellNr");
            textBox1.DataBindings.Add("Text", bindingSourceBest, "KundenCode");
        	textBox2.DataBindings.Add("Text", bindingSourceBest, "Bestelldatum");
            textBox3.DataBindings.Add("Text", bindingSourceBest, "Empfaenger");
            textBox4.DataBindings.Add("Text", bindingSourceBest, "Frachtkosten");
            
            // Anbinden der Detaildaten: 
            bindingSourcePers.DataSource = ds.Tables["Personal"];
        
            // Tabellen mittels ComboBox verknpfen:
            comboBox1.DataSource = bindingSourcePers;
         	comboBox1.DisplayMember = "Nachname";
         	comboBox1.ValueMember = "PersonalNr";           
            // Anbinden an Mastertabelle:
	        comboBox1.DataBindings.Add("SelectedValue", bindingSourceBest, "PersonalNr");            
            // Weitere Detaildaten anzeigen:
	        label6.DataBindings.Add("Text", bindingSourcePers, "Vorname");
        	label7.DataBindings.Add("Text", bindingSourcePers, "PersonalNr");
        	label8.DataBindings.Add("Text", bindingSourcePers, "Funktion");        
        }

        // Updaten der Datenbank:
        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            bindingSourceBest.EndEdit();
            try
            {
                daBest.Update(ds, "Bestellungen");    // genderte Masterdaten werden vom Dataset in Datenbank bertragen
            }
            catch (Exception ex) 
            { MessageBox.Show(ex.Message); }
        }

        // Abbruch der aktuellen Operation:
        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            bindingSourceBest.CancelEdit();
        }

        // Beenden:
        private void button1_Click(object sender, EventArgs e)
        {
            this.Close();
        }


    }
}