using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace DataReaderListView_Demo
{
    using System.Data.OleDb;

    public partial class Form1 : Form
    {
        private const string CONNSTR = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=Nordwind.mdb";

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            const string SQLSTR = "SELECT KundenCode, Firma, Funktion FROM Kunden";
	        OleDbConnection conn = new OleDbConnection(CONNSTR);
            // Nun kann ein Command-Objekt erzeugt werden:
	        OleDbCommand cmd = new OleDbCommand(SQLSTR, conn);
            // Verweis auf einen DataReader (das Instanziieren erfolgt spter, nach ffnen der Verbindung!):
	        OleDbDataReader dr = null;
            // Vorbereitung der ListView-Anzeige:
	        ListViewItem lvItem = null;

	        listView1.View = View.Details;
	        listView1.AllowColumnReorder = true;
	        listView1.FullRowSelect = true;
	        listView1.Items.Clear();
	        listView1.Columns.Add("KundenCode", 100, HorizontalAlignment.Left);
	        listView1.Columns.Add("Firma", 80, HorizontalAlignment.Left);
	        listView1.Columns.Add("Funktion", 80, HorizontalAlignment.Left);
           // DataReader-Objekt durch bergabe an die ExecuteReader-Methode des Command-Objekts instanziieren:
	        try
	        {
		        cmd.Connection.Open();
		        dr = cmd.ExecuteReader(CommandBehavior.CloseConnection); 	// DataReader wird erzeugt
               // Der Parameter CommandBehavior.CloseConnection bewirkt, 
               // dass beim Ausfhren des Befehls das zugeordnete Connection-Objekt geschlossen wird, 
               // wenn das zugeordnete DataReader-Objekt geschlossen wird.
               // Nacheinander ListViewItem-Objekte fllen und zur Items-Auflistung der ListView hinzufgen:
		       while  (dr.Read())
		       {
			       lvItem = new ListViewItem(dr["KundenCode"].ToString());
			       lvItem.SubItems.Add(dr["Firma"].ToString());
		 	       lvItem.SubItems.Add(dr["Funktion"].ToString());
			       listView1.Items.Add(lvItem);       		// Items zum ListView hinzufgen 
		       } 
	        }
	        catch (Exception ex )
	        {
		        MessageBox.Show(ex.Message);
	        }
	        cmd.Connection.Close();
      }

      private void loadAddressInfo(string kuCode)
      {
           const string SQLSTR = "SELECT Kontaktperson, Strasse, PLZ, Ort FROM Kunden WHERE KundenCode= ?";
           OleDbConnection conn = new OleDbConnection(CONNSTR);
           OleDbCommand cmd = new OleDbCommand(SQLSTR, conn);
           OleDbParameter prm = new OleDbParameter("@p", OleDbType.Char);
           OleDbDataReader dr = null;
           prm.Direction = ParameterDirection.Input;
           prm.Value = kuCode;
           cmd.Parameters.Add(prm);
           try
           {
               conn.Open();
               dr = cmd.ExecuteReader(CommandBehavior.CloseConnection);
               if (dr.Read())
               {
                   string CR = Environment.NewLine;
                   label1.Text = dr["Kontaktperson"].ToString() + CR + dr["Strasse"].ToString() + CR +
                                 dr["PLZ"].ToString() + "  " + dr["Ort"].ToString();
                   dr.Close();
               }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }

        private void listView1_Click(object sender, EventArgs e)
        {
            ListViewItem lv = listView1.SelectedItems[0];
            loadAddressInfo(lv.SubItems[0].Text);
        }
    }
}