﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        NWDataContext dcNW = new NWDataContext();

        public Form1()
        {
            InitializeComponent();
            
            var orders = from ord in dcNW.Orders
                         orderby ord.OrderDate
                         select ord;                         
          
           bindingSourceOrders.DataSource = orders;
           // bindingSourceOrders.DataSource = dcNW.Orders;
           label1.DataBindings.Add("Text", bindingSourceOrders, "OrderID");
           textBox1.DataBindings.Add("Text", bindingSourceOrders, "CustomerID");
           textBox2.DataBindings.Add("Text", bindingSourceOrders, "OrderDate", true);
           textBox3.DataBindings.Add("Text", bindingSourceOrders, "ShipName", true);
           //textBox4.DataBindings.Add("Text", bindingSourceOrders, "Freight", true);
           textBox4.DataBindings.Add("Text", bindingSourceOrders,"Freight", true, DataSourceUpdateMode.OnValidation, null, "C2");

           var employees = from emps in dcNW.Employees
                           orderby emps.LastName
                           select emps;                           

           bindingSourceEmployees.DataSource = employees;
          // bindingSourceEmployees.DataSource = dcNW.Employees;

           comboBox1.DataSource = bindingSourceEmployees;
           comboBox1.DisplayMember = "LastName";
           comboBox1.ValueMember = "EmployeeID";
           comboBox1.DataBindings.Add("SelectedValue", bindingSourceOrders, "EmployeeID",true,DataSourceUpdateMode.OnPropertyChanged);
           label6.DataBindings.Add("Text", bindingSourceEmployees, "FirstName");
           label7.DataBindings.Add("Text", bindingSourceEmployees, "EmployeeID");
           label8.DataBindings.Add("Text", bindingSourceEmployees, "Title");
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            try
            {
                dcNW.SubmitChanges();                   
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            bindingSourceOrders.CancelEdit();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.Close();
        }

       
    }
}
