﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using System.IO;
using System.Xml;
using System.Text;

public partial class Beispiel_TreeView : System.Web.UI.Page
{

    FirmaTableAdapters.MitarbeiterTableAdapter taMitarbeiter = new FirmaTableAdapters.MitarbeiterTableAdapter();
    FirmaTableAdapters.TelefonTableAdapter taTelefone = new FirmaTableAdapters.TelefonTableAdapter();
    Firma myFirma = new Firma();

    protected void Page_Load(object sender, EventArgs e)
    {
        taMitarbeiter.Fill(myFirma.Mitarbeiter);
        taTelefone.Fill(myFirma.Telefon);
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        TreeView1.Nodes.Clear();
        TreeView1.Nodes.Add(new TreeNode("Mitarbeiter"));
        foreach (Firma.MitarbeiterRow row in myFirma.Mitarbeiter)
        {
            TreeNode tn = new TreeNode();
            tn.Text = row.vorname + " " + row.nachname;
            tn.Value = row.id.ToString();
            tn.PopulateOnDemand = true;
            TreeView1.Nodes[0].ChildNodes.Add(tn);
        }
    }
    protected void TreeView1_TreeNodePopulate(object sender, TreeNodeEventArgs e)
    {
        DataRow[] rows = myFirma.Telefon.Select("MitarbeiterId="  + e.Node.Value);
        foreach (Firma.TelefonRow row in rows)
        {
            TreeNode tn = new TreeNode();
            tn.Text = "Telefon: " + row.Nummer;
            e.Node.ChildNodes.Add(tn);
        }
    }
    protected void TreeView1_SelectedNodeChanged(object sender, EventArgs e)
    {
        Label1.Text = TreeView1.SelectedNode.Text;
    }


    public string ConvertDataSetToXML(DataSet ds)
    {
        MemoryStream stream = null;
        XmlTextWriter writer = null;
        try
        {
            stream = new MemoryStream();
            writer = new XmlTextWriter(stream, Encoding.Unicode);
            ds.WriteXml(writer, XmlWriteMode.WriteSchema);
            int count = (int)stream.Length;
            byte[] arr = new byte[count];
            stream.Seek(0, SeekOrigin.Begin);
            stream.Read(arr, 0, count);
            UnicodeEncoding utf = new UnicodeEncoding();
            return utf.GetString(arr).Trim();
        }
        catch
        {
            return String.Empty;
        }
        finally
        {
            if (writer != null) writer.Close();
        }
    }

    protected void Button2_Click(object sender, EventArgs e)
    {
    }
}
