using System;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;

using System.Collections.Generic;
using System.Data;
using System.ComponentModel;

[DataObject(true)]
public class SessionWarenkorb
{
    private  List<Artikel> _ArtikelListe;
    private System.Web.SessionState.HttpSessionState Session = HttpContext.Current.Session;

    public SessionWarenkorb()
    {
        if (Session["Warenkorb"] != null)
        {
            _ArtikelListe = (List<Artikel>) Session["Warenkorb"];
        }
        else
        {
            _ArtikelListe = new List<Artikel>();
        }
    }

    [DataObjectMethod(DataObjectMethodType.Select)]
    public  List<Artikel> GetArtikelListe()
    {
        return _ArtikelListe;
    }

    [DataObjectMethod(DataObjectMethodType.Update)]
    public void UpdateArtikel(Artikel updArtikel)
    {
        foreach (Artikel art in _ArtikelListe)
        {
            if (art.Id == updArtikel.Id)
            {
                art.Bezeichnung = updArtikel.Bezeichnung;
                art.Preis = updArtikel.Preis;
                art.Anzahl = updArtikel.Anzahl;
                break;
            }
        }
        Session["Warenkorb"] = _ArtikelListe;
    }

    [DataObjectMethod(DataObjectMethodType.Delete)]
    public  void DeleteArtikel(Artikel delArtikel)
    {
        for (int i = 0; i < _ArtikelListe.Count; i++)
             if (_ArtikelListe[i].Id == delArtikel.Id) 
             {
                 _ArtikelListe.RemoveAt(i);
                 break;
             }
         Session["Warenkorb"] = _ArtikelListe;
     }

    [DataObjectMethod(DataObjectMethodType.Insert)]
    public  void InsertArtikel(Artikel insArtikel)
    {
        int Counter = 0;
        foreach (Artikel art in _ArtikelListe)
        {
            if (art.Id > Counter) Counter = art.Id;
        }
        Counter++;
        _ArtikelListe.Add(new Artikel(insArtikel.Bezeichnung, insArtikel.Preis, insArtikel.Anzahl, Counter));
        Session["Warenkorb"] = _ArtikelListe;
    }


}
