﻿using System;
using System.ComponentModel.DataAnnotations;
using System.Web;
using System.Web.DynamicData;
using System.Web.Routing;

namespace Dynamic_Data
{
    public class Global : System.Web.HttpApplication
    {
        private static MetaModel s_defaultModel = new MetaModel();
        public static MetaModel DefaultModel
        {
            get
            {
                return s_defaultModel;
            }
        }

        public static void RegisterRoutes(RouteCollection routes)
        {
            //                    WICHTIG: REGISTRIERUNG DES DATENMODELLS 
            // Kommentar für diese Zeile entfernen, um ein ADO.NET Entity Framework-Modell für ASP.NET Dynamic Data zu registrieren.
            // Legen Sie ScaffoldAllTables nur auf "true" fest, wenn Sie sicher sind, dass alle Tabellen im
            // Datenmodell eine Gerüstbauansicht (d. h. Vorlagen) unterstützen sollen. Zur Verwaltung des Gerüstbaus für
            // einzelne Tabellen muss eine Teilklasse für die Tabelle erstellt und das
            // [ScaffoldTable(true)]-Attribut für die Teilklasse übernommen werden.
            // Hinweis: Sie müssen "YourDataContextType" in den Namen der Datenkontextklasse
            // in der Anwendung ändern.
            
            DefaultModel.RegisterContext(typeof(NorthwindEntities), new ContextConfiguration() { ScaffoldAllTables = true });

            // Die folgende Anweisung unterstützt den Modus mit separaten Seiten, bei dem die Aufgaben Auflisten, Details anzeigen, Einfügen und 
            // Aktualisieren mithilfe von separaten Seiten ausgeführt werden. Zum Aktivieren des Modus muss der Kommentar für die folgende
            // route-Definition entfernt werden. Zudem müssen die Kommentare für die route-Definitionen im folgenden Abschnitt für den combined-page-Modus entfernt werden.
            //routes.Add(new DynamicDataRoute("{table}/{action}.aspx")
            //{
            //    Constraints = new RouteValueDictionary(new { action = "List|Details|Edit|Insert" }),
            //    Model = DefaultModel
            //});

            // Die folgenden Anweisungen unterstützen den combined-page-Modus, bei dem die Aufgaben Auflisten, Details anzeigen, Einfügen und
            // Aktualisieren mithilfe der gleichen Seite ausgeführt werden. Zum Aktivieren des Modus muss der Kommentar für die
            // folgenden routes entfernt werden. Zudem muss der Kommentar für die route-Definition im vorherigen Abschnitt für den Modus mit separaten Seiten entfernt werden.
            routes.Add(new DynamicDataRoute("{table}/ListDetails.aspx")
            {
                Action = PageAction.List,
                ViewName = "ListDetails",
                Model = DefaultModel
            });

            routes.Add(new DynamicDataRoute("{table}/ListDetails.aspx")
            {
                Action = PageAction.Details,
                ViewName = "ListDetails",
                Model = DefaultModel
            });
        }

        void Application_Start(object sender, EventArgs e)
        {
            RegisterRoutes(RouteTable.Routes);
        }

    }
}
