﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Windows.Forms.DataVisualization.Charting;


namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        
        private void button1_Click(object sender, EventArgs e)
        {
            var db = new NWDataContext();

            // Die LINQ Abfrage liefert einen anonymen Typ welcher die Employee Objekte enthält zusammen mit der Anzahl der von ihnen generierten Bestellungen. 
            var query = from o in db.Orders
                        group o by o.Employees
                            into g
                            select new
                            {
                                Employee = g.Key,
                                NoOfOrders = g.Count()
                            };


            // Einige Properties für das Rendering werden gesetzt, einige Fonts und labels inbegriffen: 
            chart1.Titles.Add("Sales By Employees");
            chart1.Titles[0].Font = new Font("Arial", 16f);

            chart1.ChartAreas[0].AxisX.Title = "Employee";
            chart1.ChartAreas[0].AxisY.Title = "Sales";

            chart1.ChartAreas[0].AxisX.TitleFont = new Font("Arial", 12f);
            chart1.ChartAreas[0].AxisY.TitleFont = new Font("Arial", 12f);

            chart1.ChartAreas[0].AxisX.LabelStyle.Font = new Font("Arial", 10f);
            chart1.ChartAreas[0].AxisX.LabelStyle.Angle = -45;   // Schriftwinkel zwischen 90 ... -90

            chart1.ChartAreas[0].BackColor = Color.LightYellow;

            chart1.Series[0].IsVisibleInLegend = false;   // Legende kann entfallen, da nur eine Serie

            // Die resultierenden Daten der LINQ Abfrage werden mittels AddXY()-Methode an das Chart gebunden: 
            foreach (var q in query)
            {
                var Name = q.Employee.FirstName + ' ' + q.Employee.LastName;
                chart1.Series[0].Points.AddXY(Name, Convert.ToDouble(q.NoOfOrders));
            }

            // Die Chart wird als Bilddatei abgelegt:
            chart1.SaveImage("ChartTest.bmp", ChartImageFormat.Bmp);
        }

    }
}
