﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Data.OleDb;

using System.Windows.Forms.DataVisualization.Charting;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            setSeries(chart1);
        }

        private string connStr = "PROVIDER=Microsoft.Jet.OLEDB.4.0;Data Source=ChartTest.mdb";

        private string sql = "SELECT * FROM PKW_Verkauf_1";


        // Serien definieren:
        private void setSeries(Chart chrt)
        {
            // Namen des bereits vorhandenen Series-Member für X und Y Werte setzen:
            chart1.Series["Series1"].XValueMember = "Verkäufer";
            chart1.Series["Series1"].YValueMembers = "Mercedes";
            chart1.Series["Series1"].IsVisibleInLegend = true;
            chart1.Series["Series1"].LegendText = "Mercedes";

            // Weitere Serien neu hinzufügen:
            chart1.Series.Add("Series2");
            chart1.Series["Series2"].XValueMember = "Verkäufer";
            chart1.Series["Series2"].YValueMembers = "BMW";
            chart1.Series["Series2"].LegendText = "BMW";

            chart1.Series.Add("Series3");
            chart1.Series["Series3"].XValueMember = "Verkäufer";
            chart1.Series["Series3"].YValueMembers = "Opel";
            chart1.Series["Series3"].LegendText = "Opel";

            chart1.Series.Add("Series4");
            chart1.Series["Series4"].XValueMember = "Verkäufer";
            chart1.Series["Series4"].YValueMembers = "Ford";
            chart1.Series["Series4"].LegendText = "Ford";

            chart1.Series.Add("Series5");
            chart1.Series["Series5"].XValueMember = "Verkäufer";
            chart1.Series["Series5"].YValueMembers = "Mazda";
            chart1.Series["Series5"].LegendText = "Mazda";

            chart1.Series.Add("Series6");
            chart1.Series["Series6"].XValueMember = "Verkäufer";
            chart1.Series["Series6"].YValueMembers = "Toyota";
            chart1.Series["Series6"].LegendText = "Toyota";

        }       

        // Der DataSource-Eigenschaft einen DataReader als Datenquelle zuweisen:
        private void button2_Click_1(object sender, EventArgs e)
        {
            chart1.Palette = ChartColorPalette.EarthTones;

            OleDbConnection conn = new OleDbConnection(connStr);
            OleDbCommand cmd = new OleDbCommand(sql, conn);
            cmd.Connection.Open();

            chart1.DataSource = cmd.ExecuteReader(CommandBehavior.CloseConnection);

            // Chart an die ausgewählte Datenquelle binden:
            chart1.DataBind();
            conn.Close();
        }

        // Der DataSource-Eigenschaft eine DataTable als Datenquelle zuweisen:
        private void button3_Click_1(object sender, EventArgs e)
        {
            chart1.Palette = ChartColorPalette.Fire;

            OleDbConnection conn = new OleDbConnection(connStr);
            OleDbCommand cmd = new OleDbCommand(sql, conn);
            OleDbDataAdapter da = new OleDbDataAdapter(cmd);
            DataTable dt = new DataTable();
            da.Fill(dt);

            chart1.DataSource = dt;

            // Chart an die ausgewählte Datenquelle binden:
            chart1.DataBind();
            conn.Close();
        }

        // Der DataSource-Eigenschaft ein Command-Objekt als Datenquelle zuweisen:
        private void button4_Click_1(object sender, EventArgs e)
        {
            chart1.Palette = ChartColorPalette.Excel;

            OleDbConnection conn = new OleDbConnection(connStr);
            OleDbCommand cmd = new OleDbCommand(sql, conn);

            chart1.DataSource = cmd;

            // Chart an die ausgewählte Datenquelle binden:
            chart1.DataBind();
            conn.Close();
        }

        // Der DataSource-Eigenschaft einen DataAdapter als Datenquelle zuweisen:
        private void button5_Click_1(object sender, EventArgs e)
        {
            chart1.Palette = ChartColorPalette.BrightPastel;

            OleDbConnection conn = new OleDbConnection(connStr);
            OleDbCommand cmd = new OleDbCommand(sql, conn);
            OleDbDataAdapter da = new OleDbDataAdapter(cmd);

            chart1.DataSource = da;

            // Chart an die ausgewählte Datenquelle binden:
            chart1.DataBind();
            conn.Close();
        }      
    }
}
