using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SqlConnDemo
{
    using System.Data.SqlClient;

    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        SqlConnection conn = null;
        string CrLf = Environment.NewLine;      // fr Zeilenumbruch
        
        // Variante 1:
        private void button1_Click(object sender, EventArgs e)
        {
            string connStr = "Data Source=.\\SQLEXPRESS;Initial Catalog=Northwind;Integrated Security=True";
            conn = new SqlConnection(connStr);
            connect();
        }

        // Variante 2:
        private void button2_Click(object sender, EventArgs e)
        {
            string connStr = Properties.Settings.Default.NorthwindConn;
            conn = new SqlConnection(connStr);
            connect();
        }

        // Variante 3:
        private void button3_Click(object sender, EventArgs e)
        {
            string connStr = "Data Source=.\\SQLEXPRESS;AttachDbFilename=|DataDirectory|\\Northwind.mdf;Integrated Security=True;User Instance=True";
            conn = new SqlConnection(connStr);
            connect();
        }

        // Verbindung zum Sql Server herstellen:
        private void connect()
        {
            dataGridView1.DataSource = null;

            try
            {
                conn.Open();
                MessageBox.Show("DataSource: " + conn.DataSource + CrLf + "Server Version: " + conn.ServerVersion + CrLf +
                                "TimeOut(sek): " + conn.ConnectionTimeout.ToString() + CrLf +
                                "Database: " + conn.Database,
                                "Die Verbindung wurde erfolgreich hergestellt !");
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                conn.Close();
            }

            // Kontrollanzeige:
            SqlDataAdapter da = new SqlDataAdapter("SELECT * FROM Employees", conn);
            DataTable dt = new DataTable();
            da.Fill(dt);
            dataGridView1.DataSource = dt;
        }

 
    }
}