﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;


using Microsoft.Synchronization;
using Microsoft.Synchronization.Data;
using Microsoft.Synchronization.Data.Server;

namespace LokalerCache
{
    public partial class Form1 : Form
    {

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            NWCacheSyncAgent syncAgent = new NWCacheSyncAgent();
            Microsoft.Synchronization.Data.SyncStatistics syncStats = syncAgent.Synchronize();
            listBox1.Items.Add("TotalChangesDownloaded : " + syncStats.TotalChangesDownloaded.ToString());
            this.productsTableAdapter.Fill(this.northwindDataSet.Products);
        }

        private void dataGridView1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // TODO: Diese Codezeile lädt Daten in die Tabelle "northwindDataSet.Products". Sie können sie bei Bedarf verschieben oder entfernen.
            this.productsTableAdapter.Fill(this.northwindDataSet.Products);
        }

        private void productsBindingNavigatorSaveItem_Click(object sender, EventArgs e)
        {
            this.Validate();
            this.productsBindingSource.EndEdit();
            this.tableAdapterManager.UpdateAll(this.northwindDataSet);

        }

        private void button2_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
            this.Validate();
            this.productsBindingSource.EndEdit();
            this.tableAdapterManager.UpdateAll(this.northwindDataSet);
            NWCacheSyncAgent syncAgent = new NWCacheSyncAgent();
            syncAgent.SessionProgress += new EventHandler<Microsoft.Synchronization.SessionProgressEventArgs>(syncAgent_SessionProgress);
            syncAgent.StateChanged += new EventHandler<Microsoft.Synchronization.SessionStateChangedEventArgs>(syncAgent_StateChanged);
            (syncAgent.RemoteProvider as DbServerSyncProvider).SyncProgress += new EventHandler<Microsoft.Synchronization.Data.SyncProgressEventArgs>(Form1_SyncProgress);
            syncAgent.Products.SyncDirection = Microsoft.Synchronization.Data.SyncDirection.Bidirectional;
            Microsoft.Synchronization.Data.SyncStatistics syncStats = syncAgent.Synchronize();
            listBox1.Items.Add("TotalChangesDownloaded : " + syncStats.TotalChangesDownloaded.ToString());
            this.productsTableAdapter.Fill(this.northwindDataSet.Products);
            progressBar1.Value = 0;
        }

        void Form1_SyncProgress(object sender, Microsoft.Synchronization.Data.SyncProgressEventArgs e)
        {
            string msg="";

            switch (e.SyncStage)
            {
                case SyncStage.ApplyingInserts:
                    if (e.TableProgress.Inserts > 0)  msg = "INSERT: Client -> Server " + e.TableMetadata.TableName + "[" + e.TableProgress.Inserts.ToString() + "]"; 
                    break;
                case SyncStage.ApplyingUpdates:
                    if (e.TableProgress.Updates > 0) msg = "UPDATE: Client -> Server " + e.TableMetadata.TableName + "[" + e.TableProgress.Updates.ToString() + "]"; 
                    break;
                case SyncStage.ApplyingDeletes:
                    if (e.TableProgress.Deletes > 0)  msg = "DELETE: Client -> Server " + e.TableMetadata.TableName + "[" + e.TableProgress.Deletes.ToString() + "]"; 
                    break;
                case SyncStage.GettingInserts:
                    if (e.TableProgress.Inserts > 0) msg = "INSERT: Client <- Server " + e.TableMetadata.TableName + "[" + e.TableProgress.Inserts.ToString() + "]";
                    break;
                case SyncStage.GettingUpdates:
                    if (e.TableProgress.Updates > 0)  msg = "UPDATE: Client <- Server " + e.TableMetadata.TableName + "[" + e.TableProgress.Updates.ToString() + "]";
                    break;
                case SyncStage.GettingDeletes:
                    if (e.TableProgress.Deletes > 0) msg = "DELETE: Client <- Server " + e.TableMetadata.TableName + "[" + e.TableProgress.Deletes.ToString() + "]";
                    break;
            }

            if (msg!="") listBox1.Items.Add(msg);
            Application.DoEvents();

        }

        void syncAgent_StateChanged(object sender, Microsoft.Synchronization.SessionStateChangedEventArgs e)
        {
            listBox1.Items.Add(e.SessionState.ToString());
        }

        void syncAgent_SessionProgress(object sender, Microsoft.Synchronization.SessionProgressEventArgs e)
        {
            progressBar1.Value = e.PercentCompleted;
        }


    }
}
