/****
Dieses SQL-Skript wurde über das Dialogfeld "Datensynchronisierung konfigurieren"
generiert. Dieses Skript enthält Anweisungen, mit denen die 
Spalten zur Änderungsnachverfolgung, die Tabelle für gelöschte Elemente und die Trigger
für die Serverdatenbank erstellt werden. Diese Datenbankobjekte sind für Synchronisierungsdienste
erforderlich, damit die Daten zwischen Client- und Serverdatenbanken
erfolgreich synchronisiert werden können. Weitere Informationen finden Sie im Hilfethema
"How to: Configure a Database Server for Synchronization".
****/


IF @@TRANCOUNT > 0
set ANSI_NULLS ON 
set QUOTED_IDENTIFIER ON 

GO
BEGIN TRANSACTION;


IF @@TRANCOUNT > 0
ALTER TABLE [Categories] 
ADD [LastEditDate] DateTime NULL CONSTRAINT [DF_Categories_LastEditDate] DEFAULT (GETUTCDATE()) WITH VALUES
GO
IF @@ERROR <> 0 
     ROLLBACK TRANSACTION;


IF @@TRANCOUNT > 0
ALTER TABLE [Categories] 
ADD [CreationDate] DateTime NULL CONSTRAINT [DF_Categories_CreationDate] DEFAULT (GETUTCDATE()) WITH VALUES
GO
IF @@ERROR <> 0 
     ROLLBACK TRANSACTION;


IF @@TRANCOUNT > 0
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[Categories_Tombstone]')) 
BEGIN 
CREATE TABLE [Categories_Tombstone]( 
    [CategoryID] Int NOT NULL,
    [DeletionDate] DateTime NULL
) ON [PRIMARY] 
END 

GO
IF @@ERROR <> 0 
     ROLLBACK TRANSACTION;


IF @@TRANCOUNT > 0
ALTER TABLE [Categories_Tombstone] ADD CONSTRAINT [PKDEL_Categories_Tombstone_CategoryID]
   PRIMARY KEY CLUSTERED
    ([CategoryID])
    ON [PRIMARY]
GO
IF @@ERROR <> 0 
     ROLLBACK TRANSACTION;


IF @@TRANCOUNT > 0
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'Categories_DeletionTrigger') AND type = 'TR') 
   DROP TRIGGER [Categories_DeletionTrigger] 

GO
CREATE TRIGGER [Categories_DeletionTrigger] 
    ON [Categories] 
    AFTER DELETE 
AS 
SET NOCOUNT ON 
UPDATE [Categories_Tombstone] 
    SET [DeletionDate] = GETUTCDATE() 
    FROM deleted 
    WHERE deleted.[CategoryID] = [Categories_Tombstone].[CategoryID] 
IF @@ROWCOUNT = 0 
BEGIN 
    INSERT INTO [Categories_Tombstone] 
    ([CategoryID], DeletionDate)
    SELECT [CategoryID], GETUTCDATE()
    FROM deleted 
END 

GO
IF @@ERROR <> 0 
     ROLLBACK TRANSACTION;


IF @@TRANCOUNT > 0
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'Categories_UpdateTrigger') AND type = 'TR') 
   DROP TRIGGER [Categories_UpdateTrigger] 

GO
CREATE TRIGGER [Categories_UpdateTrigger] 
    ON [Categories] 
    AFTER UPDATE 
AS 
BEGIN 
    SET NOCOUNT ON 
    UPDATE [Categories] 
    SET [LastEditDate] = GETUTCDATE() 
    FROM inserted 
    WHERE inserted.[CategoryID] = [Categories].[CategoryID] 
END;
GO
IF @@ERROR <> 0 
     ROLLBACK TRANSACTION;


IF @@TRANCOUNT > 0
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'Categories_InsertTrigger') AND type = 'TR') 
   DROP TRIGGER [Categories_InsertTrigger] 

GO
CREATE TRIGGER [Categories_InsertTrigger] 
    ON [Categories] 
    AFTER INSERT 
AS 
BEGIN 
    SET NOCOUNT ON 
    UPDATE [Categories] 
    SET [CreationDate] = GETUTCDATE() 
    FROM inserted 
    WHERE inserted.[CategoryID] = [Categories].[CategoryID] 
END;
GO
IF @@ERROR <> 0 
     ROLLBACK TRANSACTION;
COMMIT TRANSACTION;
