/****
VORSICHT
  Überprüfen Sie dieses Skript ausführlich, bevor Sie es ausführen, 
  um mögliche Probleme wegen Datenverlusten zu vermeiden.

Dieses SQL-Skript wurde mit dem Dialogfeld "Datensynchronisierung konfigurieren"
generiert. Dieses Skript ergänzt das Skript, mit dem die
erforderlichen Datenbankobjekte für die Änderungsnachverfolgung erstellt werden können. Dieses
Skript enthält Anweisungen zum Entfernen solcher Änderungen.

Weitere Informationen finden Sie im Hilfethema "How to: Configure a Database Server for Synchronization".
****/


IF @@TRANCOUNT > 0
set ANSI_NULLS ON 
set QUOTED_IDENTIFIER ON 

GO
BEGIN TRANSACTION;


IF @@TRANCOUNT > 0
ALTER TABLE [Orders] DROP CONSTRAINT [DF_Orders_LastEditDate]
GO
IF @@ERROR <> 0 
     ROLLBACK TRANSACTION;


IF @@TRANCOUNT > 0
ALTER TABLE [Orders] DROP COLUMN [LastEditDate]
GO
IF @@ERROR <> 0 
     ROLLBACK TRANSACTION;


IF @@TRANCOUNT > 0
ALTER TABLE [Orders] DROP CONSTRAINT [DF_Orders_CreationDate]
GO
IF @@ERROR <> 0 
     ROLLBACK TRANSACTION;


IF @@TRANCOUNT > 0
ALTER TABLE [Orders] DROP COLUMN [CreationDate]
GO
IF @@ERROR <> 0 
     ROLLBACK TRANSACTION;


IF @@TRANCOUNT > 0
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[Orders_Tombstone]') and TYPE = N'U') 
   DROP TABLE [Orders_Tombstone];


IF @@TRANCOUNT > 0
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'Orders_DeletionTrigger') AND type = 'TR') 
   DROP TRIGGER [Orders_DeletionTrigger] 

GO


IF @@TRANCOUNT > 0
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'Orders_UpdateTrigger') AND type = 'TR') 
   DROP TRIGGER [Orders_UpdateTrigger] 

GO


IF @@TRANCOUNT > 0
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'Orders_InsertTrigger') AND type = 'TR') 
   DROP TRIGGER [Orders_InsertTrigger] 

GO
COMMIT TRANSACTION;
