﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Data.SqlClient;
using Microsoft.SqlServer.Management.Smo;
using Microsoft.SqlServer.Management.Common;

namespace Beispiel_1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
            Server serv = new Server(textBox1.Text);
            if (checkBox1.Checked)
            {
                serv.ConnectionContext.LoginSecure = false;
                serv.ConnectionContext.Login = textBox2.Text;
                serv.ConnectionContext.Password = textBox3.Text;
            }
            foreach (Database db in serv.Databases)
            {
                if (db.IsSystemObject)
                    listBox1.Items.Add("(System) " + db.Name);
                else
                {
                    listBox1.Items.Add(db.Name + "---------------------");
                    try
                    {
                        foreach (Table t in db.Tables)
                        {
                            listBox1.Items.Add("    " + t.Name);
                        }
                    }
                    catch (Exception)
                    { }
                }
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
            DataTable dt = SmoApplication.EnumAvailableSqlServers(false);
            foreach (DataRow dr in dt.Rows)
            {
                listBox1.Items.Add(dr["Server"].ToString());
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
            Server serv = new Server(textBox1.Text);
            if (checkBox1.Checked)
            {
                serv.ConnectionContext.LoginSecure = false;
                serv.ConnectionContext.Login = textBox2.Text;
                serv.ConnectionContext.Password = textBox3.Text;
            }

            Database db =  new Database(serv, "BuchBeispiel");
            db.Create();
            Table tb = new Table(db, "ErsteTabelle");

            Column col = new Column(tb, "Id");
            col.DataType = DataType.Int;
            col.Nullable = false;
            col.Identity = true;
            col.IdentitySeed = 1;
            col.IdentityIncrement = 1;
            tb.Columns.Add(col);

            col = new Column(tb, "Nachname");
            col.DataType = DataType.VarChar(50);
            col.Nullable = false;
            tb.Columns.Add(col);

            Index idx = new Index(tb, "PK_ErsteTabelle");
            idx.IndexKeyType = IndexKeyType.DriPrimaryKey;
            idx.IndexedColumns.Add(new IndexedColumn(idx, "Id"));
            tb.Indexes.Add(idx);
            tb.Create();
        }

        private void button4_Click(object sender, EventArgs e)
        {
        }

        private void button4_Click_1(object sender, EventArgs e)
        {
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            groupBox1.Visible = checkBox1.Checked;
        }

        private void button4_Click_2(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
            Server serv = new Server(textBox1.Text);
            if (checkBox1.Checked)
            {
                serv.ConnectionContext.LoginSecure = false;
                serv.ConnectionContext.Login = textBox2.Text;
                serv.ConnectionContext.Password = textBox3.Text;
            }
            foreach (Database db in serv.Databases)
            {
                if (db.IsSystemObject)
                    listBox1.Items.Add("(System) " + db.Name);
                else
                {
                    listBox1.Items.Add(db.Name + "---------------------");
                    try
                    {
                        foreach (User u in db.Users)
                        {
                            listBox1.Items.Add("    " + u.Name);
                        }
                    }
                    catch (Exception)
                    { }
                }
            }

        }

        private void button5_Click(object sender, EventArgs e)
        {
            Server serv = new Server(textBox1.Text);
            if (checkBox1.Checked)
            {
                serv.ConnectionContext.LoginSecure = false;
                serv.ConnectionContext.Login = textBox2.Text;
                serv.ConnectionContext.Password = textBox3.Text;
            }
            Backup bck = new Backup();
            bck.Action = BackupActionType.Database;
            bck.Database = "Northwind";
            bck.Incremental = false;  // inkrementell
            bck.Initialize = true;   // überschreiben
            bck.PercentCompleteNotification = 10; 
            bck.PercentComplete += new PercentCompleteEventHandler(bck_PercentComplete);
            bck.Complete += new ServerMessageEventHandler(bck_Complete);
            bck.Devices.Add(new BackupDeviceItem(@"c:\temp\Sicherung.bak", DeviceType.File));
            bck.SqlBackup(serv);
        }

        void bck_Complete(object sender, ServerMessageEventArgs e)
        {
            MessageBox.Show("Fertig !");
            progressBar1.Value = 0;
        }

        void bck_PercentComplete(object sender, PercentCompleteEventArgs e)
        {
            progressBar1.Value = e.Percent;  
        }

        private void button6_Click(object sender, EventArgs e)
        {
            Server serv = new Server(textBox1.Text);
            if (checkBox1.Checked)
            {
                serv.ConnectionContext.LoginSecure = false;
                serv.ConnectionContext.Login = textBox2.Text;
                serv.ConnectionContext.Password = textBox3.Text;
            }
            Restore res = new Restore();
            res.Action = RestoreActionType.Database;
            res.Database = "Northwind";
            res.PercentComplete += new PercentCompleteEventHandler(bck_PercentComplete);
            res.Complete += new ServerMessageEventHandler(bck_Complete);
            res.Devices.Add(new BackupDeviceItem(@"c:\temp\Sicherung.bak", DeviceType.File));
            res.SqlRestore(serv);
        }

    }
}