﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Data.SqlServerCe;
using System.IO;

using System.Configuration;

namespace Einstieg
{
    public partial class Form1 : Form
    {
        SqlCeConnection ceconn;
        SqlCeResultSet cers;

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            SqlCeEngine engine = null;
            SqlCeConnection conn;

            using (conn = new SqlCeConnection(@"Data Source=|DataDirectory|\xyz.sdf"))
            {
                if (!File.Exists(conn.Database))
                {
                    engine = new SqlCeEngine(conn.ConnectionString);
                    engine.CreateDatabase();
                }
            }
        }


        private void button2_Click(object sender, EventArgs e)
        {
            using (SqlCeConnection conn = new SqlCeConnection(@"Data Source=|DataDirectory|\xyz.sdf"))
            {
                using (SqlCeCommand cmd = new SqlCeCommand())
                {
                    cmd.Connection = conn;
                    cmd.CommandText =
                        "CREATE TABLE Lieferanten (" +
                        "   Id  int IDENTITY PRIMARY KEY, " +
                        "   Name  nvarchar(100), " +
                        "   Telefon nvarchar(15));";
                    conn.Open();
                    cmd.ExecuteNonQuery();
                    cmd.CommandText =
                        "CREATE TABLE Ansprechpartner (" +
                        "   Id  int IDENTITY PRIMARY KEY, " +
                        "   Nachname nvarchar(20), " +
                        "   Vorname nvarchar(20), " +
                        "   Telefon nvarchar(15)," +
                        "   Firma int REFERENCES Lieferanten(Id));";
                    cmd.ExecuteNonQuery();
                }
            }
        }


        private void ProtectSection(String sectionname)
        {
            Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
            ConfigurationSection section = config.GetSection(sectionname);
            if (section != null)
            {
                if (!section.IsReadOnly())
                {
                    section.SectionInformation.ProtectSection("RsaProtectedConfigurationProvider");
                    section.SectionInformation.ForceSave = true;
                    config.Save(ConfigurationSaveMode.Modified);
                }
            }
        }



        private void button3_Click(object sender, EventArgs e)
        {
            SqlCeEngine engine = null;
            SqlCeConnection conn;

            using (conn = new SqlCeConnection(@"Data Source=|DataDirectory|\xyz.sdf"))
            {
                engine = new SqlCeEngine(conn.ConnectionString);
                engine.Compact("Data Source=;Password=geheim");
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            ceconn = new SqlCeConnection(@"Data Source=|DataDirectory|\xyz.sdf");
            using (SqlCeCommand cmd = new SqlCeCommand())
            {
                cmd.Connection = ceconn;
                ceconn.Open();
                cmd.CommandText = "SELECT * FROM Lieferanten";
                cers = cmd.ExecuteResultSet(ResultSetOptions.Updatable | ResultSetOptions.Scrollable | ResultSetOptions.Sensitive);
                dataGridView1.DataSource = cers;
            }

        }

        private void button6_Click(object sender, EventArgs e)
        {
            //cers.Delete();
            SqlCeCommand cmd = ceconn.CreateCommand();
            cmd.CommandText = "DELETE FROM Lieferanten";
            int anz = cmd.ExecuteNonQuery();
            MessageBox.Show("Es wurden " + anz.ToString() + " Datensätze gelöscht");
        }

        private void button5_Click(object sender, EventArgs e)
        {
            SqlCeUpdatableRecord rec = cers.CreateRecord();
            rec["Name"] = "Müller";
            rec["Telefon"] = "87473248274";
            cers.Insert(rec);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            ceconn = new SqlCeConnection(@"Data Source=|DataDirectory|\xyz.sdf");
            using (SqlCeCommand cmd = new SqlCeCommand())
            {
                cmd.Connection = ceconn;
                ceconn.Open();
                cmd.CommandText = "Lieferanten";
                cmd.CommandType = CommandType.TableDirect;
                cmd.IndexName = "";
                cers = cmd.ExecuteResultSet(ResultSetOptions.Updatable | ResultSetOptions.Scrollable);
                dataGridView1.DataSource = cers;
            }
        }

        private void button9_Click(object sender, EventArgs e)
        {
        }

        private void button7_Click(object sender, EventArgs e)
        {
            cers.SetString(1, "Müller-Grube");
            cers.SetString(2, "4711");
            cers.Update();

        }

        private void button9_Click_1(object sender, EventArgs e)
        {
          cers.ReadFirst();
          do
          {
              MessageBox.Show(cers["Name"].ToString());
          } while (cers.Read());
        }

        private void button10_Click(object sender, EventArgs e)
        {
            
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

    }
}
