﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.Synchronization.Data.Server;
using Microsoft.Synchronization;

namespace MobileApp
{
    public partial class Form1 : Form
    {
        NorthwindEntities db = new NorthwindEntities();

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            NWCacheSyncAgent syncAgent = new NWCacheSyncAgent();
            syncAgent.SessionProgress += new EventHandler<Microsoft.Synchronization.SessionProgressEventArgs>(syncAgent_SessionProgress);
            syncAgent.StateChanged += new EventHandler<Microsoft.Synchronization.SessionStateChangedEventArgs>(syncAgent_StateChanged);

            (syncAgent.RemoteProvider as DbServerSyncProvider).SyncProgress += new EventHandler<Microsoft.Synchronization.Data.SyncProgressEventArgs>(Form1_SyncProgress);


            Microsoft.Synchronization.Data.SyncStatistics syncStats = syncAgent.Synchronize();
            dataGridView1.DataSource = db.Products;
        }

        void Form1_SyncProgress(object sender, Microsoft.Synchronization.Data.SyncProgressEventArgs e)
        {
            string msg="";
// Auswerten der Aktion (welche Richtung, welche Aktion):
            switch (e.SyncStage)
            {
                // Der Client fügt Datensätze auf dem Server ein:
                case SyncStage.ApplyingInserts:
                    if (e.TableProgress.Inserts > 0) msg = "INSERT: Client -> Server " +
                      e.TableMetadata.TableName + "[" + e.TableProgress.Inserts.ToString() + "]";
                    break;
                // Der Client ändert Datensätze auf dem Server:
                case SyncStage.ApplyingUpdates:
                    if (e.TableProgress.Updates > 0) msg = "UPDATE: Client -> Server " +
                        e.TableMetadata.TableName + "[" + e.TableProgress.Updates.ToString() + "]";
                    break;
                // Der Client löscht Datensätze auf dem Server:
                case SyncStage.ApplyingDeletes:
                    if (e.TableProgress.Deletes > 0) msg = "DELETE: Client -> Server " +
                      e.TableMetadata.TableName + "[" + e.TableProgress.Deletes.ToString() + "]";
                    break;
                // Serverdatensätze werden auf dem Client hinzugefügt:
                case SyncStage.GettingInserts:
                    if (e.TableProgress.Inserts > 0) msg = "INSERT: Client <- Server " +
                       e.TableMetadata.TableName + "[" + e.TableProgress.Inserts.ToString() + "]";
                    break;
                // Serverdatensätze werden auf dem Client geändert:
                case SyncStage.GettingUpdates:
                    if (e.TableProgress.Updates > 0) msg = "UPDATE: Client <- Server " +
                       e.TableMetadata.TableName + "[" + e.TableProgress.Updates.ToString() + "]";
                    break;
                // Serverdatensätze werden auf dem Client gelöscht::
                case SyncStage.GettingDeletes:
                    if (e.TableProgress.Deletes > 0) msg = "DELETE: Client <- Server " +
                        e.TableMetadata.TableName + "[" + e.TableProgress.Deletes.ToString() + "]";
                    break;
            }
            if (msg!="") listBox1.Items.Add(msg);
            Application.DoEvents();
        }

        void syncAgent_StateChanged(object sender, Microsoft.Synchronization.SessionStateChangedEventArgs e)
        {
            listBox1.Items.Add(e.SessionState.ToString());
        }

        void syncAgent_SessionProgress(object sender, Microsoft.Synchronization.SessionProgressEventArgs e)
        {
            progressBar1.Value = e.PercentCompleted;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            db.SaveChanges();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            dataGridView1.DataSource = db.Products;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            db.SaveChanges();
            NWCacheSyncAgent syncAgent = new NWCacheSyncAgent();
            syncAgent.Products.SyncDirection = Microsoft.Synchronization.Data.SyncDirection.Bidirectional;
            Microsoft.Synchronization.Data.SyncStatistics syncStats = syncAgent.Synchronize();
            listBox1.Items.Add("TotalChangesDownloaded : " +
                                         syncStats.TotalChangesDownloaded.ToString());
            db.Refresh(System.Data.Objects.RefreshMode.StoreWins, db.Products);
            dataGridView1.DataSource = db.Products;
        }
    }
}
