﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Data.SQLite;
using System.IO;
using System.Runtime.InteropServices;

namespace Start
{
    public partial class Form1 : Form
    {
        SQLiteConnection conn;
        DataSet ds;
        SQLiteDataAdapter da;

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (File.Exists(AppDomain.CurrentDomain.BaseDirectory + "test.db3")) File.Delete(AppDomain.CurrentDomain.BaseDirectory + "test.db3");
            SQLiteConnection.CreateFile(AppDomain.CurrentDomain.BaseDirectory + "test.db3");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            conn = new SQLiteConnection("Data Source=" + AppDomain.CurrentDomain.BaseDirectory + "test.db3");
            conn.Open();
            conn.Close();
        }


        bool TableExists(string tblName)
        {
            return (conn.GetSchema("Tables").Select("Table_Name = '" + tblName + "'").Length > 0);
        }


        private void button3_Click(object sender, EventArgs e)
        {
            conn = new SQLiteConnection("Data Source=" + AppDomain.CurrentDomain.BaseDirectory + "test.db3");
            conn.Open();

            if (TableExists("Kunden")) MessageBox.Show("Tabelle ist vorhanden!");

            SQLiteCommand cmd = conn.CreateCommand();
            cmd.CommandText = "CREATE TABLE IF NOT EXISTS kunden (" +
                              "     Id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT," +
                              "     Vorname VARCHAR(50) NOT NULL," +
                              "     Nachname VARCHAR(50) NOT NULL," +
                              "     Telefon VARCHAR(50)" +
                              " );";
            cmd.ExecuteNonQuery();
            cmd.Dispose();
            conn.Close();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            conn = new SQLiteConnection("Data Source=" + AppDomain.CurrentDomain.BaseDirectory + "test.db3");
            conn.Open();
            da = new SQLiteDataAdapter("SELECT * FROM kunden", conn);
            da.MissingSchemaAction = MissingSchemaAction.AddWithKey;
            ds = new DataSet();
            da.Fill(ds, "Kunden");
            dataGridView1.DataSource = ds;
            dataGridView1.DataMember = "Kunden";
            conn.Close();
        }

        private void button5_Click(object sender, EventArgs e)
        {
            SQLiteCommandBuilder cb = new SQLiteCommandBuilder(da);
            conn.Open();
            da.Update(ds, "Kunden");
            conn.Close();
        }

        private void button6_Click(object sender, EventArgs e)
        {
            conn = new SQLiteConnection("Data Source=" + AppDomain.CurrentDomain.BaseDirectory + "test.db3");
            conn.Open();
            SQLiteCommand cmd = conn.CreateCommand();
            cmd.CommandText = "VACUUM;";
            cmd.ExecuteNonQuery();
        }

        private void button7_Click(object sender, EventArgs e)
        {
            conn = new SQLiteConnection("Data Source=" + AppDomain.CurrentDomain.BaseDirectory + "test.db3");
            conn.Open();

            MessageBox.Show("Jetzt wird die Datenbank angehängt!");

            SQLiteCommand cmd = conn.CreateCommand();
            cmd.CommandText = @"ATTACH DATABASE 'northwindef.db' AS XYZ;";
            cmd.ExecuteNonQuery();

            da = new SQLiteDataAdapter("SELECT * FROM XYZ.products", conn);
            ds = new DataSet();
            da.Fill(ds, "Produkte");
            dataGridView1.DataSource = ds;
            dataGridView1.DataMember = "Produkte";
            conn.Close();

        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

    }
}
