﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Linq;
using System.Data.Linq.Mapping;


namespace Beispiel
{
    public partial class TestDataContext
    {
        public void KillTeacherById(int Id)
        {
            this.ExecuteCommand("DELETE FROM student WHERE teacherid = {0}", Id);
            this.ExecuteCommand("DELETE FROM teacher WHERE id = {0}", Id);
        }

        partial void DeleteTeacher(Teacher instance)
        {
            if (instance.Geburtstag < Convert.ToDateTime("31.12.1980"))
                this.ExecuteDynamicDelete(instance);
            else
                throw new Exception("Zu alt für eine Kündigung");
        }

        //partial void DeleteTeacher(Teacher instance)
        //{
        //    this.ExecuteCommand("DELETE FROM student WHERE teacherid = {0}", instance.Id);
        //    this.ExecuteCommand("DELETE FROM teacher WHERE id = {0}", instance.Id);
        //}
    }

    public partial class Teacher
    {
        partial void OnGeburtstagChanging(DateTime value)
        {
            if (value >= DateTime.Now)
                throw new Exception("das Geburtsdatum kann ja wohl nicht stimmen ...");
        }

        partial void OnNachnameChanging(string value)
        {
            if (value == null)
                throw new Exception("Geben Sie einen Nachnamen ein!");
        }

        partial void OnValidate(ChangeAction action)
        {
            if (this.Nachname == this.Vorname)
                throw new Exception("Vorname = Nachname ????");
        }
    }

    public partial class Student
    {
        partial void OnCreated()
        {
            this._Teacher = default(EntityRef<Teacher>);
            this.Nachname = "Mustermann";
            this.Vorname = "Max";
            this.Geburtstag = DateTime.Now;
        }

        public Student(string nachname, string vorname, DateTime geb)
        {
            OnCreated();
            this._Teacher = default(EntityRef<Teacher>);
            this.Nachname = nachname;
            this.Vorname = vorname;
            this.Geburtstag = geb;
        }

        public string Name
        {
            get { return this._Vorname + ' ' + this.Nachname; }
        }

    }

    public class person
    {
        private int _Id;

        public int Id
        {
            get { return _Id; }
            set { _Id = value; }
        }
        private string _Vorname;

        public string Vorname
        {
            get { return _Vorname; }
            set { _Vorname = value; }
        }
        private string _Nachname;

        public string Nachname
        {
            get { return _Nachname; }
            set { _Nachname = value; }
        }

        public person(string nachname, string vorname, int id)
        {
            this._Id = id;
            this._Nachname = nachname;
            this._Vorname = vorname;
        }
    }

}
