@rem ---------------------------------------------------------------------------------
@rem Copyright 2008 Microsoft Corporation. All rights reserved.
@rem This is provided as sample to deploy the package using msdeploy.exe
@rem For information about IIS MSDeploy technology,
@rem please visit http://go.microsoft.com/?linkid=9278654
@rem Note: This batch file assumes the package and setparametsrs.xml are in the same folder with this file
@rem ---------------------------------------------------------------------------------
@if %_echo%!==! echo off
setlocal
@rem ---------------------------------------------------------------------------------
@rem Please Make sure you have Msdeploy install in your machine. 
@rem Alternatively, you can explicit set the MsDeployPath to the location it is on your machine
@rem set MSDeployPath="C:\Program Files\IIS\Microsoft Web Deploy\"
@rem ---------------------------------------------------------------------------------
                      
@rem ---------------------------------------------------------------------------------
@rem if user does not set MsDeployPath environment variable, we will try to retrieve it from registry.
@rem ---------------------------------------------------------------------------------
if "%MSDeployPath%" == "" (
for /F "usebackq tokens=2*" %%i  in (`reg query "HKLM\SOFTWARE\Microsoft\IIS Extensions\MSDeploy\1" /v InstallPath`) do (
if "%%~dpj" == "%%j" ( 
set MSDeployPath=%%j
)))

if not exist "%MSDeployPath%\msdeploy.exe" (
echo. msdeploy.exe is not found on this machine. Please install msdeploy before execute the script. 
echo. Please visit http://go.microsoft.com/?linkid=9278654
goto :usage
)

if /I "%1" == "" (
goto :usage
)
set RootPath=%~dp0

@rem ---------------------------------------------------------------------------------
@rem check the existance of the package file
@rem ---------------------------------------------------------------------------------
if not exist "%RootPath%Daten.Web.zip" (
echo "%RootPath%Daten.Web.zip" does not exist. 
echo This batch file relies on this deploy source file^(s^) in the same folder.
goto :usage
)

@rem ---------------------------------------------------------------------------------
@rem Execute the with /T  (simulation with -whatif)
@rem ---------------------------------------------------------------------------------
if /I "%1" == "/T" (
call :CheckParameterFile
echo. executing msdeploy.exe with -whatif 
if  not exist "%RootPath%Daten.Web.SetParameters.xml" (
echo "%MSDeployPath%\msdeploy.exe" -source:package='%RootPath%Daten.Web.zip' -dest:auto,IncludeAcls='False' -verb:sync -disableLink:AppPoolExtension -disableLink:ContentExtension -disableLink:CertificateExtension -whatif
"%MSDeployPath%\msdeploy.exe" -source:package='%RootPath%Daten.Web.zip' -dest:auto,IncludeAcls='False' -verb:sync -disableLink:AppPoolExtension -disableLink:ContentExtension -disableLink:CertificateExtension -whatif
) else (
echo "%MSDeployPath%\msdeploy.exe" -source:package='%RootPath%Daten.Web.zip' -dest:auto,IncludeAcls='False' -verb:sync -disableLink:AppPoolExtension -disableLink:ContentExtension -disableLink:CertificateExtension -setParamFile:"%RootPath%Daten.Web.SetParameters.xml" -whatif
"%MSDeployPath%\msdeploy.exe" -source:package='%RootPath%Daten.Web.zip' -dest:auto,IncludeAcls='False' -verb:sync -disableLink:AppPoolExtension -disableLink:ContentExtension -disableLink:CertificateExtension -setParamFile:"%RootPath%Daten.Web.SetParameters.xml" -whatif
)
goto :eof
) 

@rem ---------------------------------------------------------------------------------
@rem Execute the with /Y  (real deploy)
@rem ---------------------------------------------------------------------------------
if /I "%1" == "/Y" (
call :CheckParameterFile
echo. executing msdeploy.exe
if  not exist "%RootPath%Daten.Web.SetParameters.xml" (
echo. "%MSDeployPath%\msdeploy.exe" -source:package='%RootPath%Daten.Web.zip' -dest:auto,IncludeAcls='False' -verb:sync -disableLink:AppPoolExtension -disableLink:ContentExtension -disableLink:CertificateExtension
"%MSDeployPath%\msdeploy.exe" -source:package='%RootPath%Daten.Web.zip' -dest:auto,IncludeAcls='False' -verb:sync -disableLink:AppPoolExtension -disableLink:ContentExtension -disableLink:CertificateExtension
) else (
echo. "%MSDeployPath%\msdeploy.exe" -source:package='%RootPath%Daten.Web.zip' -dest:auto,IncludeAcls='False' -verb:sync -disableLink:AppPoolExtension -disableLink:ContentExtension -disableLink:CertificateExtension -setParamFile:"%RootPath%Daten.Web.SetParameters.xml"
"%MSDeployPath%\msdeploy.exe" -source:package='%RootPath%Daten.Web.zip' -dest:auto,IncludeAcls='False' -verb:sync -disableLink:AppPoolExtension -disableLink:ContentExtension -disableLink:CertificateExtension -setParamFile:"%RootPath%Daten.Web.SetParameters.xml"
)
goto :eof
)

@rem ---------------------------------------------------------------------------------
@rem Usage
@rem ---------------------------------------------------------------------------------
:usage
echo =========================================================
echo Usage:%~nx0 [/T^|/Y]
echo %~nx0 /T 
echo    This will call msdeploy.exe with -whatif flag. (simulation)
echo %~nx0 /Y 
echo    This will call msdeploy.exe to deploy the package to the location
echo Please make sure MSDeploy is install in the box.
echo
echo In addition, you can change IIS Application Name, Physical path, 
echo connectionString and other deploy parameters in the following file:
echo "%RootPath%Daten.Web.SetParameters.xml"
echo =========================================================
goto :eof

@rem ---------------------------------------------------------------------------------
@rem CheckParameterFile -- check if the package's setparamters.xml exists or not
@rem ---------------------------------------------------------------------------------
:CheckParameterFile
echo =========================================================
if  exist "%RootPath%Daten.Web.SetParameters.xml" (
echo SetParameters from:
echo "%RootPath%Daten.Web.SetParameters.xml"
echo You can change IIS Application Name, Physical path, connectionString
echo or other deploy parameters in the above file.
) else (
echo SetParamterFiles does not exist in package location.
echo Use package embedded defaultValue to deploy.
)
echo -------------------------------------------------------
goto :eof
