﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading.Tasks;
using System.Data.Services.Client;

namespace Test_01
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            NWService.NorthwindEntities svc = new NWService.NorthwindEntities(new Uri("http://services.odata.org/Northwind/Northwind.svc/"));
            var query = svc.Products;
            foreach (NWService.Product p in query)
                listBox1.Items.Add(p.ProductName);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            NWService.NorthwindEntities svc = new NWService.NorthwindEntities(new Uri("http://services.odata.org/Northwind/Northwind.svc"));
            var query = svc.CreateQuery<NWService.Product>("Products").AddQueryOption("$skip", 5).AddQueryOption("$top", 5);
            MessageBox.Show(query.RequestUri.AbsoluteUri);
            foreach (NWService.Product p in query)
                listBox1.Items.Add(p.ProductName);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            NWService.NorthwindEntities svc = new NWService.NorthwindEntities(new Uri("http://services.odata.org/Northwind/Northwind.svc/"));
            var query = svc.Products.Skip(5).Take(5);
            foreach (NWService.Product p in query)
                listBox1.Items.Add(p.ProductName);

        }

        private void button4_Click(object sender, EventArgs e)
        {
             NWService.NorthwindEntities svc = new NWService.NorthwindEntities(
                             new Uri("http://services.odata.org/Northwind/Northwind.svc/"));
            var query = (from p in svc.Products 
                         where p.UnitsInStock > 2
                         select p).Skip(5).Take(5);
            foreach (NWService.Product p in query)
                listBox1.Items.Add(p.ProductName);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            NWService.NorthwindEntities svc = new NWService.NorthwindEntities(
                            new Uri("http://services.odata.org/Northwind/Northwind.svc/"));
            var query = svc.Execute<NWService.Product>(new Uri("/Products?$top=5&$skip=5", UriKind.Relative));
            foreach (NWService.Product p in query)
                listBox1.Items.Add(p.ProductName);

        }

        private void button6_Click(object sender, EventArgs e)
        {
            var uiSched = TaskScheduler.FromCurrentSynchronizationContext();
            var token = Task.Factory.CancellationToken;

            NWService.NorthwindEntities svc = new NWService.NorthwindEntities(
                            new Uri("http://services.odata.org/Northwind/Northwind.svc/"));
           
            svc.BeginExecute<NWService.Product>(new Uri("/Products?$top=5&$skip=5", UriKind.Relative), 
                new AsyncCallback(r =>
                {
                    Task.Factory.StartNew(() =>
                    {
                        var query = svc.EndExecute<NWService.Product>(r);
                        foreach (NWService.Product p in query)
                            listBox1.Items.Add(p.ProductName);
                       
                    }, token, TaskCreationOptions.None, uiSched);
                }), null);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            var uiSched = TaskScheduler.FromCurrentSynchronizationContext();
            var token = Task.Factory.CancellationToken;

            NWService.NorthwindEntities svc = new NWService.NorthwindEntities(
                            new Uri("http://services.odata.org/Northwind/Northwind.svc/"));
            
            var query = svc.Products;
            query.BeginExecute(new AsyncCallback(r =>
                {
                    Task.Factory.StartNew(() =>
                    {
                        foreach (NWService.Product p in query.EndExecute(r))
                            listBox1.Items.Add(p.ProductName);

                    }, token, TaskCreationOptions.None, uiSched);
                }), null);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            NWService.NorthwindEntities svc = new NWService.NorthwindEntities(new Uri("http://services.odata.org/Northwind/Northwind.svc/"));
            var query = svc.Products.IncludeTotalCount();
            var response = query.Execute() as QueryOperationResponse<NWService.Product>;
            MessageBox.Show(response.TotalCount.ToString() + " Datensätze");
        }

        private void button9_Click(object sender, EventArgs e)
        {
            NWService.NorthwindEntities svc = new NWService.NorthwindEntities(new Uri("http://services.odata.org/Northwind/Northwind.svc/"));
            int i = svc.Products.Count();
            MessageBox.Show(i.ToString() + " Datensätze");

        }

        private void button10_Click(object sender, EventArgs e)
        {
            NWService.NorthwindEntities svc = new NWService.NorthwindEntities(new Uri("http://services.odata.org/Northwind/Northwind.svc/"));
            var query = svc.Products;
            dataGridView1.DataSource = query.ToList();
        }
    }
}
