﻿using System;
using System.Collections.Generic;
using System.Data.Services;
using System.Data.Services.Common;
using System.Linq;
using System.ServiceModel.Web;
using System.Web;

namespace Server
{
    public class NWService : DataService<NorthwindEntities>
    {
        // Diese Methode wird nur einmal aufgerufen, um dienstweite Richtlinien zu initialisieren.
        public static void InitializeService(DataServiceConfiguration config)
        {
            config.SetEntitySetAccessRule("*", EntitySetRights.All);
            config.SetServiceOperationAccessRule("ServiceOperation1", ServiceOperationRights.All);
            config.SetServiceOperationAccessRule("ServiceOperation2", ServiceOperationRights.All);
            config.DataServiceBehavior.MaxProtocolVersion = DataServiceProtocolVersion.V2;
        }

        [WebGet]
        public Int32 ServiceOperation1(string param1)
        {
            try
            {
                return Convert.ToInt32(param1);
            }
            catch (Exception ex)
            {
                throw new ApplicationException("An error occured: {0}", ex);
            }
        }


        [WebGet]
        public IQueryable<Products> ServiceOperation2(int anz)
        {
            NorthwindEntities ctx = this.CurrentDataSource;
            try
            {
                var prod = from p in ctx.Products
                           where p.UnitsInStock > anz
                           select p;

                return prod;
            }
            catch (Exception ex)
            {
                throw new ApplicationException("An error occured: {0}", ex);
            }
        }


    }
}
