﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class Warenkorb : MyUserControl
{

    protected void BerechneSumme()
    {
        decimal sum = 0;
        Int16 cnt = 0;
        if (dtWarenkorb.Rows.Count > 0)
        {
            foreach (DataRow row in dtWarenkorb.Rows)
            {
                sum += (decimal)row["GPreis"];
                cnt += (Int16)row["Anzahl"];
            }
            GridView2.FooterRow.Cells[5].Text = sum.ToString("c");
            GridView2.FooterRow.Cells[4].Text = "Summe";
            Button4.Visible = true;
            Button5.Visible = true;
            Label2.Visible = false;
        }
        else
        {
            Button4.Visible = false;
            Button5.Visible = false;
            Label2.Visible = true;
        }
        _FormTree.Nodes[2].Text = "Warenkorb [" + cnt.ToString() + "]";
    }


    protected void Page_Load(object sender, EventArgs e)
    {
        this.Kopfzeile = "Warenkorb";
        dtWarenkorb = (DataTable)Session["Warenkorb"];
        if (dtWarenkorb.Rows.Count != 0)
            GridView2.DataSource = dtWarenkorb;
        DataBind();
        BerechneSumme();
    }

    protected void GridView2_RowCommand(object sender, GridViewCommandEventArgs e)
    {
        Int16 anzahl;
        dtWarenkorb = (DataTable)Session["Warenkorb"];
        anzahl = (Int16)dtWarenkorb.Rows[Convert.ToInt16(e.CommandArgument)]["Anzahl"];
        if (e.CommandName == "+")
        {
            if (anzahl < 10) anzahl += 1;
            dtWarenkorb.Rows[Convert.ToInt16(e.CommandArgument)]["Anzahl"] = anzahl;
            dtWarenkorb.Rows[Convert.ToInt16(e.CommandArgument)]["GPreis"] = anzahl * (Decimal)dtWarenkorb.Rows[Convert.ToInt16(e.CommandArgument)]["EPreis"];
        }
        if (e.CommandName == "-")
        {
            if (anzahl > 0) anzahl -= 1;
            dtWarenkorb.Rows[Convert.ToInt16(e.CommandArgument)]["Anzahl"] = anzahl;
            dtWarenkorb.Rows[Convert.ToInt16(e.CommandArgument)]["GPreis"] = anzahl * (Decimal)dtWarenkorb.Rows[Convert.ToInt16(e.CommandArgument)]["EPreis"];
            if (anzahl == 0) dtWarenkorb.Rows[Convert.ToInt16(e.CommandArgument)].Delete();
            Label2.Visible = (dtWarenkorb.Rows.Count == 0);
        }
        GridView2.DataSource = dtWarenkorb;
        DataBind();
        Session["Warenkorb"] = dtWarenkorb;
        BerechneSumme();
    }

    protected void GridView2_SelectedIndexChanged(object sender, EventArgs e)
    {

    }
    protected void Button4_Click(object sender, EventArgs e)
    {
        if ((int)Session["User"] == 0)
            this.GotoPage("Anmeldung");
        else // Bereits angemeldet
            this.GotoPage("Bestellung");
    }

    protected void Button5_Click(object sender, EventArgs e)
    {
        dtWarenkorb = (DataTable)Session["Warenkorb"];
        dtWarenkorb.Rows.Clear();
        GridView2.DataSource = dtWarenkorb;
        DataBind();
        _FormTree.Nodes[2].Text = "Warenkorb";
        Session["Warenkorb"] = dtWarenkorb;
        BerechneSumme();
    }
}
