﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Microsoft.Reporting.WinForms;   // !


namespace WinFrontEnd
{
    public partial class Form1 : Form
    {
        private localhost.DOKOWebShop ws = new localhost.DOKOWebShop();
        private DataSet dsStammdaten = new DataSet();
        private DataSet dsBestellungen = new DataSet();
        private DataSet dsRechnung = new DataSet();
        private DataSet dsKunden = new DataSet();

        public Form1()
        {
            InitializeComponent();
        }

        private void MyDataChange(object sender, DataRowChangeEventArgs e)
        {
            button1.Enabled = dsStammdaten.HasChanges();
        }


        private void Form1_Load(object sender, EventArgs e)
        {
            dsStammdaten = ws.Get_Stammdaten();
            dataGridView1.DataSource = dsStammdaten.Tables["Artikelgruppen"];
            dataGridView1.Columns[0].Width = 20;    
            dataGridView1.Columns[1].HeaderText = "Artikelgruppe";
            dataGridView1.Columns[1].Width = 150;

            dataGridView2.DataSource = dsStammdaten.Tables["Artikel"];
            dataGridView2.Columns.Remove("Id");
            dataGridView2.Columns.Remove("ArtikelgruppenID");
            dataGridView2.Columns.Remove("Beschreibung");
            dataGridView2.Columns.Remove("MWStSatz");

            dataGridView2.Columns["Titel"].Width = 190;
            dataGridView2.Columns["NettoPreis"].Width = 80;
            dataGridView2.Columns["NettoPreis"].DefaultCellStyle.Format = "c";
            dataGridView2.Columns["NettoPreis"].DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;

//          Mehrwertsteuersätze auswählen
            DataGridViewComboBoxColumn cbc1 = new DataGridViewComboBoxColumn();
            cbc1.DataSource = dsStammdaten.Tables["Steuersaetze"];
            cbc1.DataPropertyName = "MwStSatz";
            cbc1.ValueMember = "Id";
            cbc1.DisplayMember = "Titel";            // Detailanzeige 
            cbc1.HeaderText = "Steuersatz";
            cbc1.Width = 130;
            cbc1.DisplayStyle = DataGridViewComboBoxDisplayStyle.Nothing;
            dataGridView2.Columns.Add(cbc1);


// Artikelgruppe auswählen
            DataGridViewComboBoxColumn cbc2 = new DataGridViewComboBoxColumn();
            cbc2.DataSource = dsStammdaten.Tables["Artikelgruppen"];
            cbc2.DataPropertyName = "ArtikelgruppenID";
            cbc2.ValueMember = "Id";
            cbc2.DisplayMember = "Titel";            // Detailanzeige 
            cbc2.HeaderText = "Artikelgruppe";
            cbc2.Width = 150;
            cbc2.DisplayStyle = DataGridViewComboBoxDisplayStyle.Nothing;
            cbc2.SortMode = DataGridViewColumnSortMode.Automatic;
            dataGridView2.Columns.Add(cbc2);

            textBox1.DataBindings.Add("Text", dsStammdaten.Tables["Artikel"], "Beschreibung");

            // Veränderungen in den Tabellen berücksichtigen
            dsStammdaten.Tables["Artikel"].RowChanged += new DataRowChangeEventHandler(MyDataChange);
            dsStammdaten.Tables["Artikelgruppen"].RowChanged += new DataRowChangeEventHandler(MyDataChange);

            // Bestellnummern abrufen
            dsBestellungen = ws.Get_Bestellungen();
            comboBox1.DataSource = dsBestellungen.Tables["Bestellungen"];
            comboBox1.DisplayMember = "Rechnung";
            comboBox1.ValueMember = "Id";
            this.reportViewer1.RefreshReport();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if ((dsStammdaten != null) && (dsStammdaten.HasChanges()))
            {
                DataSet dsHelp = dsStammdaten.GetChanges();
                if (ws.Set_Stammdaten(ref dsHelp, "tg@tg.de", "geheim"))
                {
                    dsStammdaten.Merge(dsHelp);
                    dsStammdaten.AcceptChanges();
                    button1.Enabled = false;
                    MessageBox.Show("Daten erfolgreich aktualisiert!");
                }
                else
                {
                    dsStammdaten.RejectChanges();
                    MessageBox.Show("Schreibzugriff nicht möglich! Wahrscheinlich haben Sie nicht die dazu erforderlichen Rechte.");
                }
            }
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                dsRechnung = ws.Get_BestellDetails((Int32)comboBox1.SelectedValue);
                reportViewer1.LocalReport.DataSources.Clear();
                reportViewer1.LocalReport.DataSources.Add(
                       new ReportDataSource("dsRechnungsdaten_Bestellungen",  new BindingSource(dsRechnung, "Bestellungen")));
                reportViewer1.LocalReport.DataSources.Add(
                       new ReportDataSource("dsRechnungsdaten_BestellungsDetails", new BindingSource(dsRechnung, "BestellungsDetails")));
                reportViewer1.RefreshReport();
            }
            catch
            { }
        }

        private void tabControl1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (tabControl1.SelectedIndex == 2)
            {
                dsKunden = ws.Get_Kunden();
                dataGridView3.DataSource = dsKunden.Tables["Nutzer"];
                dataGridView3.Columns.Remove("Id");
                dataGridView3.Columns["IsAdmin"].Width = 50;
            }
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
        }

        private void dataGridView1_SelectionChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked)
            {
                DataTable gridTable = (DataTable)dataGridView2.DataSource;
                gridTable.DefaultView.RowFilter = "ArtikelgruppenID = " + ((DataRowView)dataGridView1.CurrentRow.DataBoundItem).Row[0].ToString();
            }
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked)
            {
                DataTable gridTable = (DataTable)dataGridView2.DataSource;
                gridTable.DefaultView.RowFilter = "ArtikelgruppenID = " + ((DataRowView)dataGridView1.CurrentRow.DataBoundItem).Row[0].ToString();
            }
            else
            {
                DataTable gridTable = (DataTable)dataGridView2.DataSource;
                gridTable.DefaultView.RowFilter = "";
            }
        }

        private void dataGridView2_DefaultValuesNeeded(object sender, DataGridViewRowEventArgs e)
        {
            e.Row.Cells[0].Value = "?";
            e.Row.Cells[1].Value = "0";
            e.Row.Cells[2].Value = dsStammdaten.Tables["Steuersaetze"].Rows[0].Field<int>("ID").ToString();
            e.Row.Cells[3].Value = ((DataRowView)dataGridView1.CurrentRow.DataBoundItem).Row[0].ToString();
        }


        private void button2_Click(object sender, EventArgs e)
        {
            if ((dsKunden != null) && (dsKunden.HasChanges()))
            {
                DataSet dsHelp = dsKunden.GetChanges();
                if (ws.Set_Kunden(ref dsHelp, "tg@tg.de", "geheim"))
                {
                    dsKunden.Merge(dsHelp);
                    dsKunden.AcceptChanges();
                    MessageBox.Show("Daten erfolgreich aktualisiert!");
                }
                else
                {
                    dsKunden.RejectChanges();
                    MessageBox.Show("Schreibzugriff nicht möglich! Wahrscheinlich haben Sie nicht die dazu erforderlichen Rechte.");
                }
            }
        }

        private void tabPage1_Click(object sender, EventArgs e)
        {

        }

    }
}
